STK	SEGMENT	STACK
	DW	128 DUP (?)
STK	ENDS

CODE	SEGMENT	PARA
	ASSUME	CS:CODE,DS:CODE,SS:STK,ES:NOTHING

;-------------------------------------------

VINT	PROC	FAR

	CMP	AX,0012H	;640x480x16
	JZ	M50HZ
	CMP	AX,005FH	;640x480x256
	JZ	M50HZ
	PUSHF			;call old vector
	CALL	CS:OLDVINT
	IRET

M50HZ:	PUSHF			;call old vector
	CALL	CS:OLDVINT
	PUSH	AX		;save registers
	PUSH	DX
	CLI			;disable interrupts
	MOV	DX,03C2H	;adjust clock and sync pol.
	MOV	AL,227
	OUT	DX,AL
	MOV	DX,03C4H	;unlock extended registers
	MOV	AX,1206H
	OUT	DX,AX
	MOV	AL,0EH		;reset clock generator
	OUT	DX,AL
	INC	DX
	IN	AL,DX		;SR0E
	AND	AL,80H
	OR	AL,4AH
	OUT	DX,AL
	DEC	DX
	MOV	AL,1EH
	OUT	DX,AL
	INC	DX
	IN	AL,DX		;SR1E
	AND	AL,0C0H
	OR	AL,2BH
	OUT	DX,AL
	MOV	DX,03D4H	;interlace end register
	MOV	AX,2519H
	OUT	DX,AX
	MOV	AL,1AH		;interlace control
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	OR	AL,1		;set interlace flag
	OUT	DX,AL
	MOV	DX,03C4H	;divide clock by two
	MOV	AL,1
	OUT     DX,AL
	INC     DX
	IN	AL,DX
	OR	AL,8
	OUT	DX,AL
	MOV	DX,03D4H	;CRTC [11H], unlock [0..7]
	MOV	AX,0011H
	OUT	DX,AX
	MOV	AX,6000H	;CRTC [0]
	OUT	DX,AX
	MOV	AX,4F01H	;CRTC [1]
	OUT	DX,AX
	MOV	AX,5002H	;CRTC [2]
	OUT	DX,AX
	MOV	AX,8303H	;CRTC [3]
	OUT	DX,AX
	MOV	AX,5604H	;CRTC [4]
	OUT	DX,AX
	MOV	AX,9C05H	;CRTC [5]
	OUT	DX,AX
	MOV	AX,3806H	;CRTC [6]
	OUT	DX,AX
	MOV	AX,1F07H	;CRTC [7]
	OUT	DX,AX
	MOV	AX,0810H	;CRTC [10H]
	OUT	DX,AX
	MOV	AX,08A11H	;CRTC [11H], relock [0..7]
	OUT	DX,AX
	MOV	AX,0012H	;CRTC [12H]
	OUT	DX,AX
	MOV	AX,0015H	;CRTC [15H]
	OUT	DX,AX
	MOV	AX,2816H	;CRTC [16H]
	OUT	DX,AX
	STI			;enable interrupts
	POP	DX		;restore registers
	POP	AX
	IRET

VINT	ENDP

PRG_ID	DB	'TV-MODE'
OLDVINT	DD	0
PSP	DW	0

MSG1	DB	'VGA->TV-Converter V0.8 (Jul 10 1996) by Steffen Koehler',10,13,'$'
MSG2	DB	'Cirrus Logic card detected, program installed',10,13,'$'
MSG3	DB	'No Cirrus Logic card found, program not loaded',10,13,'$'
MSG4	DB	'Successfully removed from memory',10,13,'$'

START:

;print out copyright msg

	MOV	AX,CS
	MOV	DS,AX
	MOV	AH,9
	MOV	DX,OFFSET MSG1
	INT	21H

;free environment memory

	MOV	CS:PSP,ES
	MOV	AH,49H
	MOV	ES,ES:[2CH]
	INT	21H

;get vector of current video interrupt

	MOV	AX,3510H
	INT	21H
	MOV	WORD PTR CS:OLDVINT,BX
	MOV	WORD PTR CS:OLDVINT+2,ES

;check if already loaded

	MOV	SI,OFFSET PRG_ID
	MOV	DI,SI
	MOV	CX,7
	CLD
REPNZ	CMPSB
	JNZ	INIT

;remove program from memory

	MOV	AH,9
	MOV	DX,OFFSET MSG4
	INT	21H
	MOV	DX,ES:WORD PTR OLDVINT
	MOV	DS,ES:WORD PTR OLDVINT+2
	MOV	AX,2510H
	INT	21H
	MOV	ES,ES:PSP
	MOV	AH,49H
	INT	21H
	MOV	AX,4C00H
	INT	21H

;detect Cirrus Logic Chip

INIT:	MOV	DX,03C4H	;unlock extended registers
	MOV	AX,1206H
	OUT	DX,AX
	MOV	DX,03CEH	;check registers 9, A
	MOV	AL,9
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	MOV	SI,AX		;save register 9
	MOV	AL,55H
	OUT	DX,AL
	IN	AL,DX
	MOV	BL,AL
	MOV	AL,0AAH
	OUT	DX,AL
	IN	AL,DX
	MOV	BH,AL
	MOV	AX,SI		;restore register 9
	OUT	DX,AL
	MOV	DX,03CEH
	MOV	AL,0AH
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	MOV	SI,AX		;save register A
	MOV	AL,55H
	OUT	DX,AL
	IN	AL,DX
	MOV	CL,AL
	MOV	AL,0AAH
	OUT	DX,AL
	IN	AL,DX
	MOV	CH,AL
	MOV	AX,SI		;restore register A
	OUT	DX,AL
	MOV	DX,03C4H	;relock extended registers
	MOV	AX,0F06H
	OUT	DX,AX
	CMP	BX,0AA55H
	JNZ	NOCL		;non CL chip
	CMP	CX,0AA55H
	JNZ	NOCL		;non CL chip
	MOV	AH,9
	MOV	DX,OFFSET MSG2	;'Cirrus Logic detected' msg
	INT	21H

;plug in the new video interrupt routine

	MOV	DX,OFFSET VINT
	MOV	AX,2510H
	INT	21H
	MOV	AX,3100H
	MOV	DX,45
	INT	21H

;no Cirrus Chip detected

NOCL:	MOV	AH,9
	MOV	DX,OFFSET MSG3
	INT	21H
	MOV	AX,4C01H
	INT	21H

CODE	ENDS

	END	START
