STK	SEGMENT	STACK
	DW	128 DUP (?)
STK	ENDS

CODE	SEGMENT	PARA
	ASSUME	CS:CODE,DS:CODE,SS:STK,ES:NOTHING

;-------------------------------------------

VINT	PROC	FAR

	CMP	AX,0012H	;640x480x16
	JZ	M50HZ
	CMP	AX,002EH	;640x480x256
	JZ	M50HZ
	PUSHF			;call old vector
	CALL	CS:OLDVINT
	IRET

M50HZ:	PUSHF			;call old vector
	CALL	CS:OLDVINT
	PUSH	AX		;save registers
	PUSH	DX
	CLI			;disable interrupts
	MOV	DX,03C2H	;adjust clock and sync pol.
	MOV	AL,227
	OUT	DX,AL
	MOV	DX,03BFH	;unlock ET4000 specials
	MOV	AL,3
	OUT	DX,AL
	MOV	DX,03D8H
	MOV	AL,0A0H
	OUT	DX,AL
	MOV	DX,03D4H	;normal clock
	MOV	AL,34H
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	AND	AL,253
	OUT	DX,AL
	DEC	DX
	MOV	AL,35H          ;set interlace flag
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	OR	AL,80H
	OUT	DX,AL
	MOV	DX,03C4H	;set hibit
	MOV	AL,7
	OUT	DX,AL
	INC	DX
	IN	AL,DX
	OR	AL,40H
	OUT	DX,AL
	MOV	DX,03D8H	;relock ET4000 specials
	XOR	AL,AL
	OUT	DX,AL
	MOV	DX,03BFH
	MOV	AL,1
	OUT	DX,AL
	MOV	DX,03C4H        ;divide clock by two
	MOV	AL,1
	OUT     DX,AL
	INC     DX
	IN	AL,DX
	OR	AL,8
	OUT	DX,AL
	MOV	DX,03D4H	;CRTC [11H], unlock [0..7]
	MOV	AX,0011H
	OUT	DX,AX
	MOV	AX,6000H	;CRTC [0]
	OUT	DX,AX
	MOV	AX,4F01H	;CRTC [1]
	OUT	DX,AX
	MOV	AX,5002H	;CRTC [2]
	OUT	DX,AX
	MOV	AX,8303H	;CRTC [3]
	OUT	DX,AX
	MOV	AX,5604H	;CRTC [4]
	OUT	DX,AX
	MOV	AX,9C05H	;CRTC [5]
	OUT	DX,AX
	MOV	AX,7106H	;CRTC [6]
	OUT	DX,AX
	MOV	AX,0BA07H	;CRTC [7]
	OUT	DX,AX
	MOV	AX,1610H	;CRTC [10H]
	OUT	DX,AX
	MOV	AX,08A11H	;CRTC [11H], relock [0..7]
	OUT	DX,AX
	MOV	AX,0FF15H	;CRTC [15H]
	OUT	DX,AX
	MOV	AX,5016H	;CRTC [16H]
	OUT	DX,AX
	STI			;enable interrupts
	POP	DX		;restore registers
	POP	AX
	IRET

VINT	ENDP

PRG_ID	DB	'TV-MODE'
OLDVINT	DD	0
PSP	DW	0

MSG1	DB	'VGA->TV-Converter V0.8 (Jul 10 1996) by Steffen Koehler',10,13,'$'
MSG2	DB	'ET4000 card detected, program installed',10,13,'$'
MSG3	DB	'No ET4000 card found, program not loaded',10,13,'$'
MSG4	DB	'Successfully removed from memory',10,13,'$'

START:

;print out copyright msg

	MOV	AX,CS
	MOV	DS,AX
	MOV	AH,9
	MOV	DX,OFFSET MSG1
	INT	21H

;free environment memory

	MOV	CS:PSP,ES
	MOV	AH,49H
	MOV	ES,ES:[2CH]
	INT	21H

;get vector of current video interrupt

	MOV	AX,3510H
	INT	21H
	MOV	WORD PTR CS:OLDVINT,BX
	MOV	WORD PTR CS:OLDVINT+2,ES

;check if already loaded

	MOV	SI,OFFSET PRG_ID
	MOV	DI,SI
	MOV	CX,7
	CLD
REPNZ	CMPSB
	JNZ	INIT

;remove program from memory

	MOV	AH,9
	MOV	DX,OFFSET MSG4
	INT	21H
	MOV	DX,ES:WORD PTR OLDVINT
	MOV	DS,ES:WORD PTR OLDVINT+2
	MOV	AX,2510H
	INT	21H
	MOV	ES,ES:PSP
	MOV	AH,49H
	INT	21H
	MOV	AX,4C00H
	INT	21H

;detect ET4000

INIT:	MOV	CX,03D4H	;Color or Monochrome ?
	MOV	DX,03CCH
	IN	AL,DX
	AND	AL,1
	JNZ	DETECT
	MOV	CX,03B4H	;use the correct registers

DETECT:	MOV	DX,03BFH	;unlock ET4000 specials
	MOV	AL,3
	OUT	DX,AL
	ADD	CX,4
	MOV	DX,CX		;DX=03x8H
	MOV	AL,0A0H
	OUT	DX,AL
	ADD	CX,2
	MOV	DX,CX		;DX=03xAH
	IN	AL,DX		;set toggle to index
	MOV	DX,03C0H	;index 36H
	MOV	AL,36H
	OUT	DX,AL
	INC	DX
	IN	AL,DX		;get original value
	MOV	AH,AL
	XOR	AL,10H		;invert bit 4
	MOV	BL,AL
	MOV	DX,CX		;DX=03xAH
	IN	AL,DX		;set toggle to index
	MOV	DX,03C0H	;index 36H
	MOV	AL,36H
	OUT	DX,AL
	MOV	AL,BL		;write the bit inverted value
	OUT	DX,AL
	MOV	DX,CX		;DX=03xAH
	IN	AL,DX		;set toggle to index
	MOV	DX,03C0H	;index 36H
	MOV	AL,36H
	OUT	DX,AL
	INC	DX
	IN	AL,DX		;read the new value
	MOV	BH,AL
	MOV	DX,CX		;DX=03xAH
	IN	AL,DX		;set toggle to index
	MOV	DX,03C0H	;index 36H
	MOV	AL,36H
	OUT	DX,AL
	MOV	AL,AH		;write original value
	OUT	DX,AL
	SUB	CX,2
	MOV	DX,CX		;DX=03x8H
	XOR	AL,AL		;relock ET4000 specials
	OUT	DX,AL
	MOV	DX,03BFH
	MOV	AL,1
	OUT	DX,AL
	CMP	BL,BH           ;compare values
	JNZ	NOET4		;no ET4000, if not equal
	SUB	CX,4
	MOV	DX,CX		;DX=03x4H
	MOV	AL,33H		;CRTC 33H r/w if not ET3000
	OUT	DX,AL
	INC	DX
	IN	AL,DX		;read original value
	MOV	AH,AL
	XOR	AL,0FH		;invert the lower 4 bits
	MOV	BL,AL
	OUT	DX,AL		;write the bit inverted value
	IN	AL,DX		;read new value
	MOV	BH,AL
	MOV	AL,AH		;write original value
	OUT	DX,AL
	CMP	BL,BH		;compare values
	JNZ	NOET4		;ET3000, if not equal
	MOV	AH,9
	MOV	DX,OFFSET MSG2	;'ET4000 detected' msg
	INT	21H

;plug in the new video interrupt routine

	MOV	DX,OFFSET VINT
	MOV	AX,2510H
	INT	21H
	MOV	AX,3100H
	MOV	DX,45
	INT	21H

;no ET4000 detected

NOET4:	MOV	AH,9
	MOV	DX,OFFSET MSG3
	INT	21H
	MOV	AX,4C01H
	INT	21H

CODE	ENDS

	END	START
